Bug 723053 - Review Request: curlpp - a C++ wrapper for libcURL
Review Request: curlpp - a C++ wrapper for libcURL
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Susi Lehtola
Fedora Extras Quality Assurance
:
: 586291 (view as bug list)
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2011-07-18 16:52 EDT by Veeti Paananen
Modified: 2011-08-22 11:23 EDT (History)
6 users (show)

See Also:
Fixed In Version: curlpp-0.7.3-4.fc16
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-08-08 21:30:24 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
susi.lehtola: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Veeti Paananen 2011-07-18 16:52:25 EDT
Spec URL: http://rojekti.fi/files/curlpp/1/curlpp.spec
SRPM URL: http://rojekti.fi/files/curlpp/1/curlpp-0.7.3-1.fc15.src.rpm

Description:

cURLpp is a C++ wrapper for libcURL.

rpmlint:

[veeti@veeti-pc SRPMS]$ rpmlint curlpp-0.7.3-1.fc15.src.rpm 
curlpp.src: W: spelling-error Summary(en_US) libcURL -> lib Curl, lib-curl, curlicue
curlpp.src: W: spelling-error %description -l en_US libcURL -> lib Curl, lib-curl, curlicue
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

[veeti@veeti-pc result]$ rpmlint curlpp-0.7.3-1.fc15.x86_64.rpm curlpp-devel-0.7.3-1.fc15.x86_64.rpm 
curlpp.x86_64: W: spelling-error Summary(en_US) libcURL -> lib Curl, lib-curl, curlicue
curlpp.x86_64: W: spelling-error %description -l en_US libcURL -> lib Curl, lib-curl, curlicue
curlpp-devel.x86_64: W: no-manual-page-for-binary curlpp-config
2 packages and 0 specfiles checked; 0 errors, 3 warnings.

There's an old review for the same library at bug 586291. I've written this spec file from scratch.
Comment 1 Susi Lehtola 2011-07-19 06:57:03 EDT
*** Bug 586291 has been marked as a duplicate of this bug. ***
Comment 2 Susi Lehtola 2011-07-19 07:01:40 EDT
Add
 Requires: boost-devel
 Requires: libcurl-devel
to -devel, since these are probably needed in order to use the -devel package.

Please add && \ to the first lines of the conversion routine, so that it only completes when it is succesful.

Please be more verbose in %files of both packages.

You are missing %defattr in the latter %files section.

If you want to include EPEL-5 in your target, you need to add
 Requires: pkgconfig
to -devel.
Comment 3 Susi Lehtola 2011-07-19 07:03:18 EDT
Please address these issues, after which I will do the review.
Comment 4 Veeti Paananen 2011-07-19 08:01:09 EDT
Spec: http://rojekti.fi/files/curlpp/2/curlpp.spec
SRPM: http://rojekti.fi/files/curlpp/2/curlpp-0.7.3-2.fc15.src.rpm

Changelog:

* Tue Jul 19 2011 Veeti Paananen <veeti.paananen@rojekti.fi> - 0.7.3-2
- Added boost-devel, libcurl-devel and pkgconfig as requirements to devel
  subpackage.
- Complete line-ending conversion once all steps are done
- Add default file attributes to devel subpackage
- Added verbosity to file selectors

Nothing new in rpmlint.

-----------------

> Please be more verbose in %files of both packages.

I wasn't really sure what you meant with this (but decided to just explicitly define the two library files anyway): any specific examples?
Comment 5 Susi Lehtola 2011-07-19 08:59:23 EDT
(In reply to comment #4)
> > Please be more verbose in %files of both packages.
> 
> I wasn't really sure what you meant with this (but decided to just explicitly
> define the two library files anyway): any specific examples?

Yes, exactly this. Don't use wildcards if it's not necessary, i.e., there are only a few files to package. The spec file becomes a lot easier to read, since you see right away what is installed by the package.

Please be more specific also for
 %{_libdir}/pkgconfig/curlpp.pc

For clarity, I like to add a trailing / for directories:
 %{_includedir}/curlpp/
 %{_includedir}/utilspp/

***

rpmlint output:
urlpp.src: W: spelling-error Summary(en_US) libcURL -> lib Curl, lib-curl, curlicue
curlpp.src: W: spelling-error %description -l en_US libcURL -> lib Curl, lib-curl, curlicue
curlpp.x86_64: W: spelling-error Summary(en_US) libcURL -> lib Curl, lib-curl, curlicue
curlpp.x86_64: W: spelling-error %description -l en_US libcURL -> lib Curl, lib-curl, curlicue
curlpp-devel.x86_64: W: no-manual-page-for-binary curlpp-config
4 packages and 0 specfiles checked; 0 errors, 5 warnings.

These are OK.

***

MUST: The package does not yet exist in Fedora. The Review Request is not a duplicate. OK
MUST: The spec file for the package is legible and macros are used consistently. OK
MUST: The package must be named according to the Package Naming Guidelines. OK
MUST: The spec file name must match the base package %{name}. OK
MUST: The package must be licensed with a Fedora approved license and meet the  Licensing Guidelines. OK

MUST: The License field in the package spec file must match the actual license. OK
- License headers exist in some source code files, but they are not identified by licensecheck. This may be due to improper indentation.
- COPYING states that code is licensed as MIT Modern Style with sublicense.

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. OK
$ md5sum curlpp-0.7.3.tar.gz ../SOURCES/curlpp-0.7.3.tar.gz 
ccc3d30d4b3b5d2cdbed635898c29485  curlpp-0.7.3.tar.gz
ccc3d30d4b3b5d2cdbed635898c29485  ../SOURCES/curlpp-0.7.3.tar.gz

MUST: The package MUST successfully compile and build into binary rpms. OK
MUST: The spec file MUST handle locales properly. N/A
MUST: Optflags are used and time stamps preserved. OK
MUST: Packages containing shared library files must call ldconfig. OK
MUST: A package must own all directories that it creates or require the package that owns the directory. OK
MUST: Files only listed once in %files listings. OK
MUST: Debuginfo package is complete. OK
MUST: Permissions on files must be set properly. OK
MUST: Large documentation files must go in a -doc subpackage. N/A

MUST: All relevant items are included in %doc. Items in %doc do not affect runtime of application. NEEDSWORK
- Include doc/guide.pdf in -devel.

MUST: Header files must be in a -devel package. OK
MUST: Static libraries must be in a -static package. N/A
MUST: If a package contains library files with a suffix then library files ending in .so must go in a -devel package. OK
MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency. OK
MUST: Packages does not contain any .la libtool archives. OK
MUST: Desktop files are installed properly. N/A
MUST: No file conflicts with other packages and no general names. OK
SHOULD: %{?dist} tag is used in release. OK
SHOULD: If the package does not include license text(s) as separate files from upstream, the packager should query upstream to include it. OK
SHOULD: The package builds in mock. OK
EPEL: Clean section exists. OK
EPEL: Buildroot cleaned before install. OK

EPEL: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig'. NEEDSWORK
- This is only necessary if you want to ship for EPEL-5.
Comment 6 Veeti Paananen 2011-07-19 09:33:14 EDT
Spec: http://rojekti.fi/files/curlpp/3/curlpp.spec
SRPM: http://rojekti.fi/files/curlpp/3/curlpp-0.7.3-3.fc15.src.rpm

Changelog:

* Tue Jul 19 2011 Veeti Paananen <veeti.paananen@rojekti.fi> - 0.7.3-3
- Removed wildcard for selecting pkgconfig file
- Added trailing slash for directories in file listing
- Added doc/guide.pdf to development documentation

------------------

> - This is only necessary if you want to ship for EPEL-5.

That's the plan. Only problem seems to be that libcurl-devel is "curl-devel" there, but otherwise it builds fine.
Comment 7 Susi Lehtola 2011-07-19 10:51:35 EDT
(In reply to comment #6)
> > - This is only necessary if you want to ship for EPEL-5.
> 
> That's the plan. Only problem seems to be that libcurl-devel is "curl-devel"
> there, but otherwise it builds fine.

OK. You can handle this with

%if 0%{?rhel} == 5
BuildRequires: curl-devel
Requires: curl-devel
%else
BuildRequires: libcurl-devel
Requires: libcurl-devel
%endif

However, libcurl-devel provides curl-devel (it's compiled from the curl srpm), so you can just BR and R curl-devel in any case.
Comment 8 Susi Lehtola 2011-07-26 15:25:10 EDT
Hm, did you change the macro part without updating the release..? Please update the release every time you make changes to packages in review.

All the issues have been fixed, so this package has been

APPROVED
Comment 9 Veeti Paananen 2011-07-26 16:26:24 EDT
> Hm, did you change the macro part without updating the release..?

What macro part? In any case, I seem to have fixed the curl requirement locally, but I must have forgotten to upload the new spec here.
Comment 10 Veeti Paananen 2011-07-26 16:27:04 EDT
New Package SCM Request
=======================
Package Name: curlpp
Short Description: A C++ wrapper for libcURL
Owners: vpaan
Branches: f14 f15 el5 el6
InitialCC:
Comment 11 Susi Lehtola 2011-07-26 17:50:12 EDT
(In reply to comment #9)
> What macro part? In any case, I seem to have fixed the curl requirement
> locally, but I must have forgotten to upload the new spec here.

Nevermind, my mistake :D
Yes, you need(ed) to fix the curl requirement to build on EPEL-5.
Comment 12 Gwyn Ciesla 2011-07-27 06:08:33 EDT
Git done (by process-git-requests).

Added f16 as we just branched.
Comment 13 Fedora Update System 2011-07-27 10:41:31 EDT
curlpp-0.7.3-4.fc16 has been submitted as an update for Fedora 16.
https://admin.fedoraproject.org/updates/curlpp-0.7.3-4.fc16
Comment 14 Fedora Update System 2011-07-27 10:52:22 EDT
curlpp-0.7.3-4.fc15 has been submitted as an update for Fedora 15.
https://admin.fedoraproject.org/updates/curlpp-0.7.3-4.fc15
Comment 15 Fedora Update System 2011-07-27 11:00:15 EDT
curlpp-0.7.3-4.fc14 has been submitted as an update for Fedora 14.
https://admin.fedoraproject.org/updates/curlpp-0.7.3-4.fc14
Comment 16 Fedora Update System 2011-07-27 11:07:26 EDT
curlpp-0.7.3-4.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/curlpp-0.7.3-4.el6
Comment 17 Fedora Update System 2011-07-27 11:17:49 EDT
curlpp-0.7.3-4.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/curlpp-0.7.3-4.el5
Comment 18 Fedora Update System 2011-07-30 06:34:41 EDT
curlpp-0.7.3-4.el5 has been pushed to the Fedora EPEL 5 testing repository.
Comment 19 Fedora Update System 2011-08-08 21:30:17 EDT
curlpp-0.7.3-4.fc14 has been pushed to the Fedora 14 stable repository.
Comment 20 Fedora Update System 2011-08-08 21:33:17 EDT
curlpp-0.7.3-4.fc15 has been pushed to the Fedora 15 stable repository.
Comment 21 Fedora Update System 2011-08-16 16:59:10 EDT
curlpp-0.7.3-4.el6 has been pushed to the Fedora EPEL 6 stable repository.
Comment 22 Fedora Update System 2011-08-16 17:04:09 EDT
curlpp-0.7.3-4.el5 has been pushed to the Fedora EPEL 5 stable repository.
Comment 23 Fedora Update System 2011-08-22 11:23:40 EDT
curlpp-0.7.3-4.fc16 has been pushed to the Fedora 16 stable repository.

Note You need to log in before you can comment on or make changes to this bug.